/**
 *  Copyright 2005-2006 Aviad Ben Dov
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */


package com.crp.whirl;

public final class MachineFactory {

	public static Machine create() {
		Wheel mathWheel = new Wheel(
			MathCommand.Noop, MathCommand.Load, MathCommand.Store,
			MathCommand.Add, MathCommand.Mult, MathCommand.Div, 
			MathCommand.Zero, MathCommand.IsLesser, MathCommand.IsGreater,
			MathCommand.IsEqual, MathCommand.Not, MathCommand.Neg
		);

		Wheel logicWheel = new Wheel(
			LogicCommand.Noop, LogicCommand.Exit, LogicCommand.One,
			LogicCommand.Zero, LogicCommand.Load, LogicCommand.Store,
			LogicCommand.PAdd, LogicCommand.DAdd, LogicCommand.Logic,
			LogicCommand.If, LogicCommand.IntIO, LogicCommand.AscIO
		);

		return new Machine(logicWheel, mathWheel, true);
	}
}

